"use strict";
var core_1 = require('@angular/core');
var ExtBase = (function () {
    function ExtBase(myElement, componentFactoryResolver, viewContainerRef, metaData) {
        var _this = this;
        this.listeners = {};
        this.myElement = myElement;
        this.componentFactoryResolver = componentFactoryResolver;
        this.viewContainerRef = viewContainerRef;
        this.metaData = metaData;
        this.xtype = metaData.XTYPE;
        this.inputs = metaData.INPUTNAMES;
        this.rootElement = myElement.nativeElement;
        var me = this;
        this['ready'] = new core_1.EventEmitter();
        metaData.OUTPUTS.forEach(function (event, n) {
            _this[event.name] = new core_1.EventEmitter();
            _this.listeners[event.name] = function () {
                var parameters = event.parameters;
                var parms = parameters.split(',');
                var args = Array.prototype.slice.call(arguments);
                var o = {};
                for (var i = 0, j = parms.length; i < j; i++) {
                    o[parms[i]] = args[i];
                }
                me[event.name].next(o);
            };
        });
    }
    ExtBase.iterateIt = function (MetaData) {
        for (var key in MetaData.OUTPUTS) {
            var name = MetaData.OUTPUTS[key].name;
            MetaData.OUTPUTNAMES.push(name);
        }
    };
    ExtBase.prototype.AfterContentInit = function (ExtJSBaseRef) {
        var extJSRootComponentRef = ExtJSBaseRef.first;
        var firstExtJS = extJSRootComponentRef['_element'].component.extjsObject;
        firstExtJS.setRenderTo(this.myElement.nativeElement);
        var ExtJSComponentRefArray = ExtJSBaseRef.toArray();
        var arrayLength = ExtJSComponentRefArray.length;
        for (var i = 1; i < arrayLength; i++) {
            var obj = ExtJSComponentRefArray[i]['_element'].component.extjsObject;
            firstExtJS.add(obj);
        }
    };
    ExtBase.prototype.OnInit = function (dynamicTarget) {
        var me = this;
        var o = {};
        o.listeners = {};
        o.listeners['select'] = function (list, record, eOpts) { me.select.next({ list: list, record: record, eOpts: eOpts }); };
        o.listeners['selectionchange'] = function (list, node) { me.selectionchange.next({ list: list, node: node }); };
        o.listeners['tap'] = function (obj, e, eOpts) { me.tapit.next({ obj: obj, e: e }); };
        o.xtype = me.xtype;
        if (me.xtype != '') {
            o.xtype = me.xtype;
        }
        for (var i = 0; i < me.metaData.INPUTNAMES.length; i++) {
            var prop = me.metaData.INPUTNAMES[i];
            if (me[prop] != undefined) {
                o[prop] = me[prop];
            }
            ;
        }
        if (true == me.fit) {
            o.top = 0,
                o.left = 0,
                o.width = '100%',
                o.height = '100%';
        }
        if (me.config !== {}) {
            Ext.apply(o, me.config);
        }
        ;
        me.extjsObject = Ext.create(o);
        var componentFactory;
        var type;
        if (me.component != undefined) {
            type = me.component;
            componentFactory = me.componentFactoryResolver.resolveComponentFactory(type);
            me.componentRef = dynamicTarget.createComponent(componentFactory);
            var node = me.extjsObject.innerElement.dom;
            node.appendChild(me.componentRef['_hostElement'].nativeElement);
        }
        if (me.parent != undefined) {
            me.parent.insert(0, me.extjsObject);
        }
        me.ready.next(me);
    };
    return ExtBase;
}());
exports.ExtBase = ExtBase;
//# sourceMappingURL=ext.base.js.map